
/******************************************************************************
* MODULE     : content.hpp
* DESCRIPTION: Wrapper for symbolic type without header dependencies
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MML_CONTENT_HPP
#define __MML_CONTENT_HPP
namespace mml {

class string;
class integer;
class rational;
class symbolic;
class content_rep;

class content {
STATIC_INDIRECT_PROTO (content, content_rep)
public:
  content ();
  content (int i);
  content (char* s);
  content (const string& s);
  content (const integer& i);
  content (const rational& r);
  content (const symbolic& s);
  friend class content_rep;
};

void lisp_print (ostream& out, const content& c);
ostream& operator << (ostream& out, const content& c);

content& operator << (content& c1, const content& c2);
content apply (const content& c1);
content apply (const content& c1, const content& c2);
content apply (const content& c1, const content& c2, const content& c3);

content tuple (const content& c);
content vtuple (const content& c);
content sqtuple (const content& c);

content operator - (const content& c1);
content operator + (const content& c1, const content& c2);
content operator - (const content& c1, const content& c2);
content operator * (const content& c1, const content& c2);
content operator / (const content& c1, const content& c2);
content operator % (const content& c1, const content& c2);
content pow (const content& c1, const content& c2);

} // namespace mml
#endif // __MML_CONTENT_HPP
