
/******************************************************************************
* MODULE     : symbolic_out.cpp
* DESCRIPTION: Output of symbolic expressions
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "symbolic.hpp"
namespace mml {

void
lisp_print (ostream& out, const symbolic& s) {
  if (is_atomic (s)) out << L(s);
  else {
    nat i, n= N(s);
    out << "(";
    lisp_print (out, s[0]);
    for (i=1; i<=n; i++) {
      out << " ";
      lisp_print (out, s[i]);
    }
    out << ")";
  }
}

ostream&
operator << (ostream& out, const symbolic& s) {
  //lisp_print (out, flatten (s));
  pretty_print (out, flatten (s));
  return out;
}

} // namespace mml
