
/******************************************************************************
* MODULE     : symbolic_test.cc
* DESCRIPTION: Test symbolic expressions
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "symbolic_aux.hpp"
using namespace mml;

int
main () {
  symbolic x ("x");
  symbolic y ("y");
  symbolic z (111111111);
  cout << "x\t= " << x << "\n";
  cout << "y\t= " << y << "\n";
  cout << "z\t= " << z << "\n";
  cout << "x*y\t= " << (x*y) << "\n";
  cout << "x=y\t= " << (x==y) << "\n";
  cout << "x!=y\t= " << (x!=y) << "\n";
  cout << "x+1\t= " << (x+1) << "\n";
  cout << "z*z\t= " << z*z << "\n";
  cout << "z*z*z\t= " << z*z*z << "\n";
  cout << "z/7\t= " << z/7 << "\n";
  cout << "z/111\t= " << z/111 << "\n\n";

  cout << "x x\t\t\t= " << x*x << "\n";
  cout << "2 x y\t\t\t= " << 2*x*y << "\n";
  cout << "2 x y + y x\t\t= " << 2*x*y + y*x << "\n";
  cout << "2 x y + x y\t\t= " << 2*x*y + x*y << "\n";
  cout << "2 x y - y x\t\t= " << 2*x*y - y*x << "\n";
  cout << "2 x y - y x - x y\t= " << 2*x*y - y*x - x*y << "\n";
  cout << "x (x + y)\t\t= " << x*(x+y) << "\n";
  cout << "(x + y) (x - y)\t\t= " << (x+y) * (x-y) << "\n";
  cout << "2 (x + y) - x\t\t= " << 2*(x+y) - x << "\n\n";

  cout << "x x / x\t\t\t= " << x*x/x << "\n";
  cout << "(x^2)^3\t\t\t= " << pow (pow (x, symbolic(2)), symbolic(3)) << "\n";
  cout << "(x^x)^y\t\t\t= " << pow (pow (x, x), y) << "\n";
  cout << "(x y)^y\t\t\t= " << pow (x*y, y) << "\n";
  cout << "(x y)^y / x\t\t= " << pow (x*y, y) / x << "\n";
  cout << "(x y)^y / (x y)\t\t= " << pow (x*y, y) / (x*y) << "\n";
  cout << "(x y)^y / (x y)^2\t= " << pow(x*y,y) / pow(x*y,symbolic(2)) << "\n";
  cout << "((x + y)^x)^y\t\t= " << pow (pow (x+y, x), y) << "\n";

  return 0;
}
